#include "visual.h"
#include "config.h"

GtkWidget 
  *Main;

GdkWindowAttr attr;

GdkPixmap 
  *StandPixmap,
  *MovePixmap,
  *BlinkPixmap;

GdkBitmap
  *StandMask,
  *MoveMask,
  *BlinkMask;

void init_window()
{

  Main = gtk_window_new ( GTK_WINDOW_TOPLEVEL );

  gtk_signal_connect( GTK_OBJECT(Main), "destroy",
		      GTK_SIGNAL_FUNC(close_application), NULL);
  gtk_widget_set_usize( Main, 50, 100 );

  attr.window_type = GDK_WINDOW_CHILD;
  attr.wclass = GDK_INPUT_OUTPUT;
  attr.width = 50;
  attr.height = 100;

  Main->window = gdk_window_new(
			  NULL, &attr, 0);
  gtk_widget_show(Main);
  gdk_window_show(Main->window);
  
  return;
}


void init_pixmaps( gchar **Standxpm, gchar **Movexpm, gchar **Blinkxpm )
{
  

  StandPixmap = gdk_pixmap_create_from_xpm_d(
					  Main->window,
					  &StandMask,
					  NULL,
					  Standxpm);
  
  MovePixmap = gdk_pixmap_create_from_xpm_d(
                                          Main->window,
					  &MoveMask,
					  NULL,
					  Movexpm);
                                            
  BlinkPixmap = gdk_pixmap_create_from_xpm_d(
						Main->window,
						&BlinkMask,
						NULL,
						Blinkxpm);

return;

}

/********************************  Displaying Pixmaps  ************************/

gint display_pixmap(GdkPixmap *DisplayPixmap, GdkBitmap *DisplayMask )
{

   gdk_window_set_back_pixmap(
			     Main->window,
			     DisplayPixmap,
			     0);
   gdk_window_shape_combine_mask(
				Main->window,
				DisplayMask,
				0,0);
  gdk_window_clear(Main->window);
  gdk_flush();
 
  return(TRUE);
}

/*
 *
 * Callbacks to display different Pixmaps after waiting a set amount of time
 *
 */

gint display_stand()
{
  display_pixmap( StandPixmap, StandMask );

  return(FALSE);
}

gint display_blink()
{
  display_pixmap( BlinkPixmap, BlinkMask );
  return(FALSE);
}

gint display_move()
{
  display_pixmap( MovePixmap, MoveMask );

  return(FALSE);
}


void init_mars_visuals()
{
  init_pixmaps( mars_stand_xpm, mars_move_xpm, mars_blink_xpm );
}

void init_moon_visuals()
{
  init_pixmaps( moon_stand_xpm, moon_move_xpm, moon_blink_xpm );
}

void init_jupiter_visuals()
{
  init_pixmaps( jupiter_stand_xpm, jupiter_move_xpm, jupiter_blink_xpm );
}

void init_venus_visuals()
{
  init_pixmaps( venus_stand_xpm, venus_move_xpm, venus_blink_xpm );
}

void init_mercury_visuals()
{
  init_pixmaps( mercury_stand_xpm, mercury_move_xpm, mercury_blink_xpm );
}

gint window_raise()
{

      gdk_window_raise( Main->window );

  return(TRUE);
}
